<template>
  <div class="d-flex flex-column px-md-16 px-4 w-100">
    <div class="d-flex flex-sm-row flex-column align-center justify-space-between w-100 py-8">
      <div class="d-flex flex-column">
        <h2>Rollen Rechte verwalten</h2>
        <span>Hier kannst du die Rollen Rechte verwalten.</span>
      </div>

      <div class="d-flex flex-row mt-sm-0 mt-8 ml-sm-4">
        <RoleRightCreate @submitted="loadRoleRights()" />
      </div>
    </div>

    <v-container class="pa-0 ma-0">
      <v-row>
        <v-col cols="12" xl="3" lg="4" md="6" sm="12" v-for="roleRight of roleRights" :key="roleRight.id">
          <v-card :title="roleRight.name" :subtitle="getSubtitle(roleRight)" link>
            <v-card-actions class="d-flex justify-end mt-n4">
              <RoleRightPatch :roleRight="roleRight" @submitted="loadRoleRights()" />
              <RoleRightDelete :roleRight="roleRight" @submitted="loadRoleRights()" />
            </v-card-actions>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, ref } from "vue";

import { api, RoleRightResponse } from "../../api";

import RoleRightCreate from "../../components/RoleRightCreate.vue";
import RoleRightDelete from "../../components/RoleRightDelete.vue";
import RoleRightPatch from "../../components/RoleRightPatch.vue";

const roleRights = ref<RoleRightResponse[]>([]);

function getSubtitle(roleRight: RoleRightResponse): string {
  const count = roleRight._count.roles || 0;
  return `Benutzt in ${count} ${count === 1 ? 'Rolle' : 'Rollen'}`;
}

async function loadRoleRights(): Promise<void> {
  const { data, status, statusText } = await api.roleRights.getAllRoleRights();

  if (status !== 200) {
    console.error(statusText);
    return;
  }
  roleRights.value = data;
}

onMounted(loadRoleRights);
</script>
